"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializer = void 0;
const fs_1 = require("fs");
const logger_1 = __importStar(require("../common/logger"));
const configUtils_1 = require("./utils/configUtils");
const outputs_1 = require("./outputs");
const ci_1 = __importDefault(require("./utils/ci"));
const consts_1 = require("../common/consts");
function initializer(config) {
    var _a;
    return __awaiter(this, void 0, void 0, function* () {
        logger_1.setVerbose((_a = config.verbose) !== null && _a !== void 0 ? _a : false);
        logger_1.default.info(`Start BundleMon v${consts_1.version}`);
        const normalizedConfig = Object.freeze(configUtils_1.validateConfig(config));
        if (!normalizedConfig) {
            logger_1.default.debug(`Config\n${JSON.stringify(config, null, 2)}`);
            return undefined;
        }
        logger_1.default.debug(`Normalized config:\n${JSON.stringify(normalizedConfig, null, 2)}`);
        logger_1.default.debug(`CI vars:\n${JSON.stringify(ci_1.default, null, 2)}`);
        const { baseDir } = normalizedConfig;
        logger_1.default.info(`base directory: "${baseDir}"`);
        if (!fs_1.existsSync(baseDir)) {
            logger_1.default.error(`base directory "${baseDir}" not found`);
            return undefined;
        }
        try {
            yield outputs_1.initOutputs(normalizedConfig);
        }
        catch (err) {
            logger_1.default.error(err.message);
            return undefined;
        }
        return normalizedConfig;
    });
}
exports.initializer = initializer;
