"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDiffPercentText = exports.getDiffSizeText = exports.getSignText = exports.parseOutput = void 0;
const bytes_1 = __importDefault(require("bytes"));
function parseOutput(output) {
    if (Array.isArray(output)) {
        return { name: output[0], options: output[1] };
    }
    return { name: output, options: undefined };
}
exports.parseOutput = parseOutput;
function getSignText(num) {
    return num > 0 ? '+' : '';
}
exports.getSignText = getSignText;
function getDiffSizeText(size) {
    return `${getSignText(size)}${bytes_1.default(size)}`;
}
exports.getDiffSizeText = getDiffSizeText;
function getDiffPercentText(percent) {
    if (percent === Infinity) {
        return '';
    }
    return `${getSignText(percent)}${percent}%`;
}
exports.getDiffPercentText = getDiffPercentText;
